#include <iostream>
#include <vector>

typedef long long ll;
const ll MOD = 1000000009;

using namespace std;

ll k;
vector<vector<ll>> tree;

// guaranteed at least 2 nodes
ll search(int v, ll avail, ll par) {
    ll nc = tree[v].size() - (v?1:0);
    // cout << v << ' ' << avail << ' ' << par << ' ' << nc << endl;
    if (avail < nc) return 0;

    ll ans = 1;
    for (ll i = 0, used = 0; i < tree[v].size(); ++i, ++used) {
        ll w = tree[v][i];
        if (w == par) {
            --used;
            continue;
        }

        ll rec = ((avail-used)*search(w, k-tree[v].size(), v))%MOD;
        ans = (ans*rec)%MOD;
        // cout << w << ' ' << ans << endl;
    }
    return ans;
}

int main() {
    int n, t;
    cin >> t;
    for (int cno = 1; cno <= t; ++cno) {
        cin >> n >> k;
        tree.clear();
        tree.resize(n);
        while (--n) {
            ll u, v;
            cin >> u >> v;
            --u; --v;
            tree[u].push_back(v);
            tree[v].push_back(u);
        }

        cout << "Case #" << cno << ": " << search(0, k, -1) << endl;
    }

    return 0;
}
