#include <iostream>
#include <iomanip>
#include <vector>

typedef long long ll;

using namespace std;

ll pcnt(ll p, ll n) {
    ll c = 0;
    for (ll pp = p; pp <= n; pp *= p)
        c += n/pp;
    return c;
}

ll powmod(ll a, ll b, ll m) {
    a %= m;
    ll ans = 1, x = a;
    while (b) {
        if (b&1) ans = (ans*x)%m;
        x = (x*x)%m;
        b >>= 1;
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    vector<bool> p(n+1, true), cnt(n+5, 0);

    for (ll i = 2; i <= n; ++i)
        if (p[i])
            for (ll j = i*i; j <= n; j += i)
                p[j] = false;

    ll ans = 1;
    for (int i = 2; i <= n; ++i) {
        if (p[i] && i != 5) {
            ll c = pcnt(i, n);
            if (i == 2) c -= pcnt(5, n);
            ans = (ans*powmod(i, c, 1000ll))%1000;
        }
    }

    if (n > 6) cout << setw(3) << setfill('0');
    cout << ans << endl;

    return 0;
}
